# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

from enum import Enum, EnumMeta
from six import with_metaclass

class _CaseInsensitiveEnumMeta(EnumMeta):
    def __getitem__(self, name):
        return super().__getitem__(name.upper())

    def __getattr__(cls, name):
        """Return the enum member matching `name`
        We use __getattr__ instead of descriptors or inserting into the enum
        class' __dict__ in order to support `name` and `value` being both
        properties for enum members (which live in the class' __dict__) and
        enum members themselves.
        """
        try:
            return cls._member_map_[name.upper()]
        except KeyError:
            raise AttributeError(name)


class ProvisioningState(with_metaclass(_CaseInsensitiveEnumMeta, str, Enum)):
    """The current deployment state of PowerBI Dedicated resource. The provisioningState is to
    indicate states for resource provisioning.
    """

    DELETING = "Deleting"
    SUCCEEDED = "Succeeded"
    FAILED = "Failed"
    PAUSED = "Paused"
    SUSPENDED = "Suspended"
    PROVISIONING = "Provisioning"
    UPDATING = "Updating"
    SUSPENDING = "Suspending"
    PAUSING = "Pausing"
    RESUMING = "Resuming"
    PREPARING = "Preparing"
    SCALING = "Scaling"

class SkuTier(with_metaclass(_CaseInsensitiveEnumMeta, str, Enum)):
    """The name of the Azure pricing tier to which the SKU applies.
    """

    PBIE_AZURE = "PBIE_Azure"

class State(with_metaclass(_CaseInsensitiveEnumMeta, str, Enum)):
    """The current state of PowerBI Dedicated resource. The state is to indicate more states outside
    of resource provisioning.
    """

    DELETING = "Deleting"
    SUCCEEDED = "Succeeded"
    FAILED = "Failed"
    PAUSED = "Paused"
    SUSPENDED = "Suspended"
    PROVISIONING = "Provisioning"
    UPDATING = "Updating"
    SUSPENDING = "Suspending"
    PAUSING = "Pausing"
    RESUMING = "Resuming"
    PREPARING = "Preparing"
    SCALING = "Scaling"
